<?php
/*
Purpose: JSON Frontend to DNS Travseral script.
Author: Mike Jones (mike@mikejones.in)

I started off trying to make it neat and tidy and standards compliant but, well this was what I ended up with!
I wouldn't normally release something with as many hacks and workarounds and known problems as this but I have
had several requests for a copy of the script, so here you go...

*/

/* Remove comments to disable IPv4/IPv6 */
// $GLOBALS['IPv4']=false;
// $GLOBALS['IPv6']=false;

if (get_magic_quotes_gpc()) {
	function strip_slashes_deep($value){
		return is_array($value) ? array_map(strip_slashes_deep, $value) : stripslashes($value);
	};
	$_GET = array_map(strip_slashes_deep, $_GET);
	$_POST = array_map(strip_slashes_deep, $_POST);
	$_COOKIE = array_map(strip_slashes_deep, $_COOKIE);
}
?>
<html>
<head>
	<title>Complete DNS Trace</title>
	<link rel="shortcut icon" href="favicon.ico" />
	<link type="text/css" href="css/overcast/jquery-ui-1.8.16.custom.css" rel="stylesheet" />	
	<script type="text/javascript" src="js/jquery-1.6.2.min.js"></script>
	<script type="text/javascript" src="js/jquery-ui-1.8.16.custom.min.js"></script>
	<style>
	.add-padding	{padding:20px;}
	.ui-loading	{float:left; text-align:center; width:20px;}
	.hidden-results	{display:none;}
	a:hover	{color:#000000;}
	</style>
	<script type="text/javascript">
	var Loading = 0;
	var LoadAnimation = ['|','/','-','\\'];
	var HadResponse = [];
	function Response(server, data)
	{
		HadResponse[server] = true;
		Loading = (Loading + 1)%LoadAnimation.length;
		$('span.ui-loading').text(LoadAnimation[Loading] + ' ');
		
		var previous = $('div[name="' + server + '"]');
		var header;
		var contents;
		var entry;
		if (!previous.length)
		{
			entry = $('<div>').addClass('ui-widget').attr('name', server);
			header = $('<div>').addClass('ui-widget-header').addClass('ui-corner-top').addClass('ui-state-active');
			contents = $('<div>').addClass('ui-widget-content').addClass('ui-corner-bottom').addClass('add-padding');
			entry.append(header);
			entry.append(contents);
			$("#results").append(entry);
		}
		else
		{
			previous.each(function (index){
			
				$(this).find('.ui-widget-header').text("").append($('<a>').text(server + ' (' + $(this).attr('hostname') + ') ' + $(this).attr('delegationflags')).attr('href','#' + server));
				$(this).find('.ui-widget-content').text("").removeClass('add-padding');
			});
			//previous.find('.ui-widget-header').text("").append($('<a>').text(server).attr('href','#' + server));
			//previous.find('.ui-widget-content').text("").removeClass('add-padding');
			entry = previous.first();
			contents = entry.find('.ui-widget-content');
			contents.text('').addClass('add-padding');
			header = entry.find('.ui-widget-header');
			header.addClass('ui-state-active');
		}
		
		if (entry.attr('hostname') && entry.attr('delegationflags'))
			header.text(server + ' (' + entry.attr('hostname') + ') ' + entry.attr('delegationflags'));
		else if (entry.attr('hostname'))
			header.text(server + ' (' + entry.attr('hostname') + ')');
		else
			header.text(server);
		header.prepend($('<a>').attr('name', server));

		if (!data['header'])
		{
			contents.append($('<div>').text('Server Error'));
		}
		else
		{
			var result = $('<div>');
			if (data['delegations'])
			{
				result.addClass('hidden-results');
				var showlink = $('<a>').attr('href','#' + server).text("Show Response");
				showlink.click(function(){
					$(this).parent().find('.hidden-results').first().removeClass('hidden-results');
					$(this).addClass('hidden-results');
					return false;
				});
				if (server != 'IANA Root')
				{
					contents.append(showlink);
				}
			}
			contents.append(result);
			var Status = "";
			if (data['header']['aa'] == 1)
				Status += "AA ";
			if (data['header']['tc'] == 1)
				Status += "TC ";
			if (data['header']['rd'] == 1)
				Status += "RD ";
			if (data['header']['ra'] == 1)
				Status += "RA ";
			Status += data['header']['rcode'];
			result.append($('<div>').text(Status));
			
			if (data['answer'][0])
			{
				result.append($('<div>').text('Answer:'));
				var responsetable = $('<table>');
				for (x in data['answer'])
				{
					var answer = $('<tr>');
					for (field in data['answer'][x])
					{
						if (field == 'cname')
							answer.append($('<td>').append($('<a>').attr('href', '?type=<?php echo $_GET['type'];?>&hostname=' + escape(data['answer'][x][field])).text(data['answer'][x][field])));
						else if (field == 'text')
						{
							for (i in data['answer'][x][field])
								answer.append($('<td>').text(data['answer'][x][field][i]));
						}
						else
							answer.append($('<td>').text(data['answer'][x][field]));
						answer.append($('<td>').width('40px'));
					}
					responsetable.append(answer);
				}
				result.append(responsetable);
			}

			if (data['authority'][0])
			{
				result.append($('<div>').text('Authority:'));
				var responsetable = $('<table>');
				for (x in data['authority'])
				{
					var authority = $('<tr>');
					for (field in data['authority'][x])
					{
						authority.append($('<td>').text(data['authority'][x][field]));
						authority.append($('<td>').width('20px'));
					}
					responsetable.append(authority);
				}
				result.append(responsetable);
			}

			if (data['additional'][0])
			{
				result.append($('<div>').text('Additional:'));
				var responsetable = $('<table>');
				for (x in data['additional'])
				{
					var additional = $('<tr>');
					for (field in data['additional'][x])
					{
						additional.append($('<td>').text(data['additional'][x][field]));
						additional.append($('<td>').width('20px'));
					}
					responsetable.append(additional);
				}
				result.append(responsetable);
			}
			
			if (data['delegations'])
			{
				for (x in data['delegations'])
				{
					var flags = '';
					if (data['delegations'][x]['glue'] && !data['delegations'][x]['lookup'])
						flags += 'Invalid Host?';
					else if (!data['delegations'][x]['glue'] && data['delegations'][x]['lookup'])
						flags += 'No Glue';
					var subheader = $('<div>').addClass('ui-widget-header').addClass('ui-corner-top');
					subheader.text(data['delegations'][x]['address'] + ' (' + data['delegations'][x]['name'] + ') ' + flags).prepend($('<span>').addClass('ui-loading').html('&nbsp;'));
					var subcontents = $('<div>').addClass('ui-widget-content').addClass('ui-corner-bottom').addClass('add-padding');
					var subentry = $('<div>').addClass('ui-widget');
					subentry.attr('name', data['delegations'][x]['address']);
					subentry.attr('hostname', data['delegations'][x]['name']);
					subentry.attr('delegationflags', flags);
					if (HadResponse[data['delegations'][x]['address']])
					{
						subheader.text("").append($('<a>').text(data['delegations'][x]['address'] + ' (' + data['delegations'][x]['name'] + ') ' + flags).attr('href','#' + data['delegations'][x]['address']));
						subcontents.text("").removeClass('add-padding');
					}
					subentry.append(subheader).append(subcontents);
					contents.append(subentry);
				}
			}
		}
	};
	</script>
</head>
<body>
	<div id="query">
		<form method="GET" action="?">
			<input name="hostname" value="<?php echo isset($_GET['hostname'])?htmlentities($_GET['hostname']):'google.com';?>" />
			<select name="type">
			<?php
			$types = array('A', 'AAAA', 'NS', 'MX', 'TXT', 'PTR', 'SRV', 'CNAME', 'SPF', 'SOA', 'NULL', 'ANY');
			foreach ($types as $type)
			{
				$sel = (isset($_GET['type']) && $type == $_GET['type'])?' SELECTED':'';
				echo '<option value="' . $type . '"' . $sel . '>' . $type . '</option>' . "\n";
			}
			?>
			</select>
			<input type="submit" value="Trace" />
		</form>
	</div>
	<div id="results" style="display:inline-block;">
	</div>
	<div>
		<a href="http://www.mikejones.in/dns.tar.gz">Get Source</a>
	</div>
</body>
</html>
<?php
if (isset($_GET['hostname']))
{
	require_once 'json.php';
	require_once 'dnstrace.php';

	function DNSCallback($server, $reply)
	{
		echo '<script type="text/javascript">Response("'. $server . '", ' . JSON($reply) . ');</script>' . "\r\n";
		flush();
	}
	$hostname = $_GET['hostname'];
	$type = isset($_GET['type'])&&$_GET['type']?$_GET['type']:'ANY';
	$replies = DoLookup($hostname, $type, 'DNSCallback');
}	
?>
